//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#include <TFT_eSPI.h>
#include <SPI.h>
TFT_eSPI display = TFT_eSPI(135, 240);
#include <TFT_eFEX.h>              // Include the extension graphics functions library
TFT_eFEX  fex = TFT_eFEX(&display);
//T//FT_eSprite spr = TFT_eSprite(&display);
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// some principal color definitions
// RGB 565 color picker at https://ee-programming-notepad.blogspot.com/2016/10/16-bit-color-generator-picker.html
   #define WHITE       0xFFFF
   #define BLACK       0x0000
   #define BLUE        0x001F
   #define RED         0xF800
   #define GREEN       0x07E0
   #define CYAN        0x07FF
   #define MAGENTA     0xF81F
   #define YELLOW      0xFFE0
   #define GREY        0x2108 
   #define SCALE0      0xC655                                                  // accent color for unused scale segments                                   
   #define SCALE1      0x5DEE                                                  // accent color for unused scale segments
   #define TEXT_COLOR  0xFFFF                                                  // is currently white 


#ifndef TFT_DISPOFF
#define TFT_DISPOFF 0x28
#endif

#ifndef TFT_SLPIN
#define TFT_SLPIN   0x10
#endif

#define TFT_MOSI            19
#define TFT_SCLK            18
#define TFT_CS              5
#define TFT_DC              16
#define TFT_RST             23

#define TFT_BL              4   // Display backlight control pin
#define ADC_EN              14  // ADC_EN is the ADC detection enable port
#define ADC_PIN             34

         

//#define TFT_BL          4  // Display backlight control pin

int ledBacklight = 255;  //int ledBacklight = 80; // Initial TFT backlight intensity on a scale of 0 to 255. Initial value is 80.

#define BTN_UP 35 // Pinnumber for button for up/previous and select / enter actions (don't change this if you want to use the onboard buttons)
//#define BTN_UP 27
#define BTN_DWN 0 // Pinnumber for button for down/next and back / exit actions (don't change this if you want to use the onboard buttons)

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


#define PROG_VERSION "0.2" // Don't change this!

#include <Button2.h>
#include "bmp.h"
#include <menu.h>
#include <menuIO/serialIO.h>
#include <menuIO/TFT_eSPIOut.h>
// #include <menuIO/chainStream.h>
#include <menuIO/esp8266Out.h>//must include this even if not doing web output...
using namespace Menu;

Button2 btnUp(BTN_UP); // Initialize the up button
Button2 btnDwn(BTN_DWN); // Initialize the down button

result doAlert(eventMask e, prompt &item);

   //int bateryCtrl = 0;                                                                                               
   int climaCtrl = 0;
   int lightCtrl = 0;
   int somCtrl = 0;
   int SpectrographCtrl=0;
   int MagCtrl=0;
   int analogMeterCtrl=0;
   int gpsdisplayCtrl=0;
   int thermocamCtrl =0;
   int geigerCtrl = 0;
   int stormCtrl = 0;
   int atmosphereCtrl = 0;
   int lidarCtrl = 0;
   int betaCtrl = 0;
   int RecvCtrl = 0;
   int oscilloscopeCtrl = 0;
                                                                                                            

// Setting PWM properties, do not change this!
const int pwmFreq = 5000;
const int pwmResolution = 8;
const int pwmLedChannelTFT = 0;


//customizing a prompt look!
//by extending the prompt class
class altPrompt:public prompt {
public:
  altPrompt(constMEM promptShadow& p):prompt(p) {}
  Used printTo(navRoot &root,bool sel,menuOut& out, idx_t idx,idx_t len,idx_t) override {
    return out.printRaw(F("special prompt!"),len);;
  }
};

result jose(){

}


const char* constMEM hexDigit MEMMODE="0123456789ABCDEF";
const char* constMEM hexNr[] MEMMODE={"0","x",hexDigit,hexDigit};
char buf1[]="0x11";

MENU(mainMenu,"    MAIN MENU",doNothing,noEvent,wrapStyle
  //,OP("BATERY",batery ,enterEvent) 
  ,OP("CLIMA_TEMPO",clima ,enterEvent)  
  ,OP("LIGHT_UV",light ,enterEvent)
  ,OP("SOUND_ANALYZER",som ,enterEvent)
  ,OP("SPECTROGRAPH" ,Spectrograph, enterEvent)
  ,OP("MAGNETOMETER" ,Mag, enterEvent)
  ,OP("RF SENSOR" ,analogMeter, enterEvent)
  ,OP("GPS" ,gpsdisplay,enterEvent)
  ,OP("THERMOCAM" ,thermocam,enterEvent)
  ,OP("GEIGER" , geiger, enterEvent)
  ,OP("ION SENSOR" , storm, enterEvent)
  ,OP("ATMOS" , atmosphere, enterEvent)
  ,OP("DIST" , lidar, enterEvent)
  ,OP("THYNDAL", beta, enterEvent)
  ,OP("SONDA", Recv, enterEvent)
  ,OP("OSCILL", oscilloscope, enterEvent)
 
);

// define menu colors --------------------------------------------------------
//  {{disabled normal,disabled selected},{enabled normal,enabled selected, enabled editing}}
//monochromatic color table

#define Black RGB565(0,0,0)
#define Red  RGB565(255,0,0)
#define Green RGB565(0,255,0)
#define Blue RGB565(0,0,255)
#define Gray RGB565(128,128,128)
#define LighterRed RGB565(255,150,150)
#define LighterGreen RGB565(150,255,150)
#define LighterBlue RGB565(150,150,255)
#define DarkerRed RGB565(150,0,0)
#define DarkerGreen RGB565(0,150,0)
#define DarkerBlue RGB565(0,0,150)
#define Cyan RGB565(0,255,255)
#define Magenta RGB565(255,0,255)
#define Yellow RGB565(255,255,0)
#define White RGB565(255,255,255)

const colorDef<uint16_t> colors[6] MEMMODE={
  {
    {
      (uint16_t)Black,
      (uint16_t)Black
    },
    {
      (uint16_t)Black,
     // (uint16_t)DarkerBlue,
     (uint16_t)DarkerGreen,
      //(uint16_t)DarkerBlue,
      (uint16_t)DarkerGreen,
    }
  },//bgColor
  
  {
    {
      (uint16_t)Gray,
      (uint16_t)Gray
     
    },
    {
      (uint16_t)White,
      (uint16_t)White,
      (uint16_t)White
    }
    
  },//fgColor
  
  {
    {
      (uint16_t)White,
      (uint16_t)Black
    },
    {
      (uint16_t)Yellow,
      (uint16_t)Yellow,
      (uint16_t)Red
    }
  },//valColor
  {
    {
      (uint16_t)White,
      (uint16_t)Black
    },
    {
      (uint16_t)White,
      (uint16_t)Yellow,
      (uint16_t)Yellow
    }
  },//unitColor
  {
    {
      (uint16_t)White,
      (uint16_t)Gray
      
    },
    {
      (uint16_t)Black,
      //(uint16_t)Blue,
      (uint16_t)Green,
      (uint16_t)White
    }
  },//Cor da moldura do cursor
  {
    {
      (uint16_t)White,
      (uint16_t)Yellow
    },
    {
      (uint16_t)DarkerRed,
      (uint16_t)White,
      (uint16_t)White
    }
  },//Cores do Titulo - Menu Principal
};

#define MAX_DEPTH 5
#define LED_1 17

serialIn serial(Serial);

//MENU_INPUTS(in,&serial);its single, no need to `chainStream`

//define serial output device
idx_t serialTops[MAX_DEPTH]={0};
serialOut outSerial(Serial,serialTops);

#define fontW 12
#define fontH 18

const panel panels[] MEMMODE = {{0, 0, 240 / fontW, 135 / fontH}};
navNode* nodes[sizeof(panels) / sizeof(panel)]; //navNodes to store navigation status
panelsList pList(panels, nodes, 1); //a list of panels and nodes
idx_t eSpiTops[MAX_DEPTH]={0};
TFT_eSPIOut eSpiOut(display,colors,eSpiTops,pList,fontW,fontH+1);
menuOut* constMEM outputs[] MEMMODE={&outSerial,&eSpiOut};//list of output devices
outputsList out(outputs,sizeof(outputs)/sizeof(menuOut*));//outputs list controller

NAVROOT(nav,mainMenu,MAX_DEPTH,serial,out);

unsigned long idleTimestamp = millis();

                      //when menu is suspended
                      result idle(menuOut& o,idleEvent e) {
                      if (e==idling) { 
                       
                           nav.doNav(escCmd);
                          wrapStyle;                //Volta ao estilo de letras do menu principal. Sem isso o menu principal reaparece escrito com a letrinhas de Sound Analyzer
  
                          digitalWrite(LED_1, LOW);
                      
                           //bateryCtrl =0;
                           climaCtrl =0;
                           lightCtrl =0;
                           somCtrl =0; 
                           SpectrographCtrl =0; 
                           MagCtrl = 0;
                           analogMeterCtrl = 0;
                           gpsdisplayCtrl = 0;
                           thermocamCtrl = 0;
                           geigerCtrl = 0;
                           stormCtrl = 0;
                           atmosphereCtrl = 0;
                           lidarCtrl = 0;
                           betaCtrl = 0;
                           RecvCtrl = 0; 
                           oscilloscopeCtrl = 0;                                          
                       }         
                     return proceed;
                   }
//////////////////////////////////////////////////////////////////////////////////////////////////////////

//????????????????????????????????
#include <math.h>

//////////////////////////////////////////////////////////////////////////////////////////////////////////
//SOUNDS

#include <Tone32.h>
#define BUZZER_PIN 13
#define BUZZER_CHANNEL 1
                  
//////////////////////////////////////////////////////////////////////////////////////////////////////////
//SPECTRUM ANALISER

#include <Arduino.h>
#include <driver/adc.h>
#include <complex.h>
#define FREQ2IND (SAMPLES * 1.0 / MAX_FREQ)
#include "params.h"
#define MIC 32
#define BUTTON_3            37


unsigned long chrono, chrono1;
unsigned long sampling_period_us;
byte peak[SAMPLES] = {0};
float complex data[SAMPLES];
const int nTimes = 54; // number of acquisitions in a row (700 ms total)
uint16_t data2D[SAMPLES][nTimes];
int sound[SAMPLES];
float MULT = MAX_FREQ * 1000.0 / SAMPLES;
unsigned int P2P = 0;
const int LOG2SAMPLE = log(SAMPLES) / log(2);
int32_t backgroundSound = 0;
#include "functions.h"
#define MODE 19
#define MAXMODES 7

/////////////////////////////////////////////////////////////////////////////////////////////////////////
//BATERIA

#include <Pangodream_18650_CL.h>
#define ADC_PIN 34
#define CONV_FACTOR 1.7
#define READS 20
Pangodream_18650_CL BL;

/////////////////////////////////////////////////////////////////////////////////////////////////////////
//SONDA

#include <esp_now.h>
#include <WiFi.h>
#define CHANNEL 1


float temperature;
float humidity;
float pressure;

float TempReading=0;
float incomingTemp;
float incomingHum;
float incomingPres;
String success;

//Structure example to send data
//Must match the receiver structure
typedef struct struct_message {
    float temp;
    float hum;
    float pres;
} struct_message;

// Create a struct_message called BME280Readings to hold sensor readings
struct_message BME280Readings;

// Create a struct_message to hold incoming sensor readings
struct_message incomingReadings;

esp_now_peer_info_t peerInfo;


//////////////////////////////////////////////////////////////////////////////////////////////////////////
//MAGNETOMETER

#include "MPU9250.h"
MPU9250 IMU(Wire, 0x68);

//////////////////////////////////////////////////////////////////////////////////////////////////////////
//SPECTROGRAPH

     #include "AS7265X.h"
     #include <Wire.h>

     #define TFT_BLACK   0x0000
     #define TFT_BLUE    0x001F
     #define TFT_RED     0xF800
     #define TFT_GREEN   0x07E0
     #define TFT_CYAN    0x07FF
     #define TFT_MAGENTA 0xF81F
     #define TFT_YELLOW  0xFFE0
     #define TFT_WHITE   0xFFFF
     #define TFT_ORANGE  0xFBE0
     #define TFT_GRAY    0x7BEF

      #define intPin 27

      float adc0f, adc1f, adc2f, adc3f,
      freq_max = 0,
      alpha_t_max=0,
      alpha_r_max=0;

      bool intFlag = false;
     
      uint8_t MAJOR; 
      uint8_t PATCH; 
      uint8_t BUILD; 
      uint8_t statos;
   
     float    calData[18];
     float    i0trans[18] = { 25.69, 5890.84, 34177.45, 332.51, 14256.25, 17561.38, 13007.37, 13324.39, 35649.63, 2024.64, 6494.61, 3110.50, 2156.96, 2164.27, 2701.11, 1487.51, 448.46, 137.48 };
     float   i0refl[18] = { 1183.56, 19419.89, 43419.51, 19574.48, 30105.70, 28799.66, 19446.79, 26549.77, 49003.55, 15261.67, 22949.33, 5555.62, 5361.28, 4079.55, 2924.67, 1980.31, 800.81, 761.25 };
     //float   i0refl[18] = {0.05575, 0.55481, 1.03525, 0.67031, 0.89070, 0.91643, 0.53963, 0.49553, 1.51515, 0.40917, 0.74838, 0.19775, 0.21108, 0.11223, 0.13195, 0.08675, 0.02002, 0.02909};
     float     alpha_t[18];
     float     alpha_r[18];
     float    Isum;
         
     int16_t  rawData[18];
     uint16_t freq[18] = {610, 680, 730, 760, 810, 860, 560, 585, 645, 705, 900, 940, 410, 435, 460, 485, 510, 535}, // latest data sheet
         freq_d[18];

     int freqSort[18] = {12, 13, 14, 15, 16, 17, 6, 7, 0, 8, 1, 9, 2, 3, 4, 5, 10, 11}, 
     tab1,tab2,tab3,
     //h,minute_d,s,d,m,y,t_d,v,
     SenseT1, SenseT2, SenseT3,
     nachkomma=3,
     offsettextY=16;//,
     //pause=50;

     uint8_t ledIndCurrent0 = led_ind_1_mA, ledDrvCurrent0 = led_drv_12_5_mA;
     uint8_t ledIndCurrent1 = led_ind_1_mA, ledDrvCurrent1 = led_drv_25_mA;
     uint8_t ledIndCurrent2 = led_ind_1_mA, ledDrvCurrent2 = led_drv_50_mA;

     int inTime = 36, intTime_d;  //36*2.5;

     uint8_t gain = gain_16x;
     uint8_t mode = mode2;
     uint8_t intTime = inTime;

     char modus,     modus_d = 'N';

     int gainX=16, gainX_d, i, i_d, k, j,l,n,yE, i0;

     unsigned long t;
     float ts, LEDcurrent,LEDcurrent_d,vf;

     AS7265X AS7265X(intPin);  

//////////////////////////////////////////////////////////////////////////////////////////////////////////
//LIGHT and UV

#include "Adafruit_SI1145.h" 
Adafruit_SI1145 uv = Adafruit_SI1145();

//////////////////////////////////////////////////////////////////////////////////////////////////////////
//CLIMA TEMPO
#include <Adafruit_BME280.h>
#define SEALEVELPRESSURE_HPA (1013.25)
Adafruit_BME280 bme; // I2C


///////////////////////////////////////////////////////////////////////////////////////////////////////////
//RF - MICROWAVES

#define Volt 39
#define M_SIZE 1
#define TFT_GREY 0x5AEB
float ltx = 0;    // Saved x coord of bottom of needle
uint16_t osx = M_SIZE*120, osy = M_SIZE*120; // Saved x & y coords
uint32_t updateTime = 0;       // time for next update

int old_analog =  -999; // Value last displayed

int value[6] = {0, 0, 0, 0, 0, 0};
int old_value[6] = { -1, -1, -1, -1, -1, -1};
int d = 0;


const int entradaAnalogica = 39; // Pino de entrada analógica
const int numLeituras = 10; // Número de leituras para a média
const int fatorAmplificacao = 200; // Fator de amplificação

///////////////////////////////////////////////////////////////////////////////////////////////////////////
//GPS

#include <Adafruit_GPS.h>
Adafruit_GPS GPS(&Wire);
#define GPSECHO false
uint32_t timer = millis();

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
//THERMAL

#include <Adafruit_AMG88xx.h>

//low range of the sensor (this will be blue on the screen)
//#define MINTEMP 20
#define MINTEMP 15
//high range of the sensor (this will be red on the screen)
//#define MAXTEMP 28
#define MAXTEMP 40

//the colors we will be using
const uint16_t camColors[] = {0x480F,
0x400F,0x400F,0x400F,0x4010,0x3810,0x3810,0x3810,0x3810,0x3010,0x3010,
0x3010,0x2810,0x2810,0x2810,0x2810,0x2010,0x2010,0x2010,0x1810,0x1810,
0x1811,0x1811,0x1011,0x1011,0x1011,0x0811,0x0811,0x0811,0x0011,0x0011,
0x0011,0x0011,0x0011,0x0031,0x0031,0x0051,0x0072,0x0072,0x0092,0x00B2,
0x00B2,0x00D2,0x00F2,0x00F2,0x0112,0x0132,0x0152,0x0152,0x0172,0x0192,
0x0192,0x01B2,0x01D2,0x01F3,0x01F3,0x0213,0x0233,0x0253,0x0253,0x0273,
0x0293,0x02B3,0x02D3,0x02D3,0x02F3,0x0313,0x0333,0x0333,0x0353,0x0373,
0x0394,0x03B4,0x03D4,0x03D4,0x03F4,0x0414,0x0434,0x0454,0x0474,0x0474,
0x0494,0x04B4,0x04D4,0x04F4,0x0514,0x0534,0x0534,0x0554,0x0554,0x0574,
0x0574,0x0573,0x0573,0x0573,0x0572,0x0572,0x0572,0x0571,0x0591,0x0591,
0x0590,0x0590,0x058F,0x058F,0x058F,0x058E,0x05AE,0x05AE,0x05AD,0x05AD,
0x05AD,0x05AC,0x05AC,0x05AB,0x05CB,0x05CB,0x05CA,0x05CA,0x05CA,0x05C9,
0x05C9,0x05C8,0x05E8,0x05E8,0x05E7,0x05E7,0x05E6,0x05E6,0x05E6,0x05E5,
0x05E5,0x0604,0x0604,0x0604,0x0603,0x0603,0x0602,0x0602,0x0601,0x0621,
0x0621,0x0620,0x0620,0x0620,0x0620,0x0E20,0x0E20,0x0E40,0x1640,0x1640,
0x1E40,0x1E40,0x2640,0x2640,0x2E40,0x2E60,0x3660,0x3660,0x3E60,0x3E60,
0x3E60,0x4660,0x4660,0x4E60,0x4E80,0x5680,0x5680,0x5E80,0x5E80,0x6680,
0x6680,0x6E80,0x6EA0,0x76A0,0x76A0,0x7EA0,0x7EA0,0x86A0,0x86A0,0x8EA0,
0x8EC0,0x96C0,0x96C0,0x9EC0,0x9EC0,0xA6C0,0xAEC0,0xAEC0,0xB6E0,0xB6E0,
0xBEE0,0xBEE0,0xC6E0,0xC6E0,0xCEE0,0xCEE0,0xD6E0,0xD700,0xDF00,0xDEE0,
0xDEC0,0xDEA0,0xDE80,0xDE80,0xE660,0xE640,0xE620,0xE600,0xE5E0,0xE5C0,
0xE5A0,0xE580,0xE560,0xE540,0xE520,0xE500,0xE4E0,0xE4C0,0xE4A0,0xE480,
0xE460,0xEC40,0xEC20,0xEC00,0xEBE0,0xEBC0,0xEBA0,0xEB80,0xEB60,0xEB40,
0xEB20,0xEB00,0xEAE0,0xEAC0,0xEAA0,0xEA80,0xEA60,0xEA40,0xF220,0xF200,
0xF1E0,0xF1C0,0xF1A0,0xF180,0xF160,0xF140,0xF100,0xF0E0,0xF0C0,0xF0A0,
0xF080,0xF060,0xF040,0xF020,0xF800,};

Adafruit_AMG88xx amg;
unsigned long delayTime;

#define AMG_COLS 8
#define AMG_ROWS 8
float pixels[AMG_COLS * AMG_ROWS];

#define INTERPOLATED_COLS 24
#define INTERPOLATED_ROWS 24

float HighTemp = 0;
float HTemp = 0;

float get_point(float *p, uint8_t rows, uint8_t cols, int8_t x, int8_t y);
void set_point(float *p, uint8_t rows, uint8_t cols, int8_t x, int8_t y, float f);
void get_adjacents_1d(float *src, float *dest, uint8_t rows, uint8_t cols, int8_t x, int8_t y);
void get_adjacents_2d(float *src, float *dest, uint8_t rows, uint8_t cols, int8_t x, int8_t y);
float cubicInterpolate(float p[], float x);
float bicubicInterpolate(float p[], float x, float y);
void interpolate_image(float *src, uint8_t src_rows, uint8_t src_cols, 
                       float *dest, uint8_t dest_rows, uint8_t dest_cols);

//////////////////////////////////////////////////////////////////////////////////////////////////////////////
//FIELDS

#include <Free_Fonts.h>
#include "lcars15pt7b.h"
#include "lcars11pt7b.h"

// Drawing Meter Bar 
#define Y2_POS            105
#define Y_POS             75
#define X_Pos             0
#define BAR_GAP           4
#define BAR_HEIGHT        2
#define BAR_WIDTH         20//(TFT_WIDTH -80)
#define MIN_LEVEL         13
#define MAX_LEVEL         36

#define MIN_LEVEL2         13
#define MAX_LEVEL2         36

int preLevel = 13;
int preLevel2 = 13;
int level;
double Leq_dB;
double Leq_dB2;
// Drawing Meter Bar Color
uint16_t redInactiveColor = fex.luminance(255, 0, 0, 16);
uint16_t yellowInactiveColor = fex.luminance(255, 255, 0, 16);
uint16_t greenInactiveColor = fex.luminance(0, 255, 0, 16);
uint16_t redActiveColor = fex.luminance(255, 0, 0, 196);
uint16_t yellowActiveColor = fex.luminance(255, 255, 0, 196);
uint16_t greenActiveColor = fex.luminance(0, 255, 0, 196);
float MagM ;                      

//////////////////////////////////////////////////////////////////////////////////////////////////////////////
//GEIGER

                      #include "RadiationWatch.h"
                      RadiationWatch radiationWatch;

//////////////////////////////////////////////////////////////////////////////////////////////////////////////

//Air Quality

                      #include "Adafruit_CCS811.h"
                      Adafruit_CCS811 ccs;

////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//LIDAR tempo de voo

                       #include <VL53L1X.h>
                       VL53L1X sensor;
                
/////////////////////////////////////////////////////////////////////////////////////////////////////////////
//THINDAL
                      #include "MAX30105.h"
                      MAX30105 particleSensor;

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
//OSCILOSCOPE

//#include <Arduino.h>
#include <driver/i2s.h>
#include <driver/adc.h>
#include <soc/syscon_reg.h>
#include "esp_adc_cal.h"
#include "filters.h"

#define DELAY 1000

#define WIDTH  135
#define HEIGHT 240

#define ADC_CHANNEL   ADC1_CHANNEL_5  // GPIO33
#define NUM_SAMPLES   1000            // number of samples
#define I2S_NUM         (0)
#define BUFF_SIZE 20000
#define B_MULT BUFF_SIZE/NUM_SAMPLES

       
 
esp_adc_cal_characteristics_t adc_chars;

float v_div = 825;
float s_div = 20;
float coffset = 0;
float toffset = 0;
uint8_t current_filter = 1;

//options handler
enum Option {
  None,
  Autoscale,
  Vdiv,
  Sdiv,
//  coffset,
 // TOffset,
 // Filter,
 // Stop,
 // Mode,
 // Single,
 // Clear,
 // Reset,
 // Probe,
//  UpdateF,
 // Cursor1,
 // Cursor2
};

int8_t volts_index = 0;

int8_t tscale_index = 0;

uint8_t opt = None;

bool menus = false;
bool info = true;
bool set_value  = false;

float RATE = 1000; //in ksps --> 1000 = 1Msps

bool auto_scale = false;

bool full_pix = true;

bool stop = false;

bool stop_change = false;

uint16_t i2s_buff[BUFF_SIZE];

bool single_trigger = false;
bool data_trigger = false;

bool updating_screen = false;
bool new_data = false;
bool menu_action = false;
uint8_t digital_wave_option = 0; //0-auto | 1-analog | 2-digital data (SERIAL/SPI/I2C/etc)


///////////////////////////////////////////////////////////////////////////////////////////////////////////////
//config myOptions('*','-',defaultNavCodes,false);

void button_init()
{
  
    btnUp.setLongClickHandler([](Button2 & b) {
        // Select
        unsigned int time = b.wasPressedFor();
        if (time >= 1000) {
          nav.doNav(enterCmd);
                                                                                
        }
    });

    btnUp.setClickHandler([](Button2 & b) {
       // Up
       nav.doNav(downCmd); // It's called downCmd because it decreases the index of an array. Visually that would mean the selector goes upwards.
    });

    btnDwn.setLongClickHandler([](Button2 & b) {
         //Exit
        unsigned int time = b.wasPressedFor();
        if (time >= 1000) {
          nav.doNav(escCmd);
         
                                                                           
        }
    });

    btnDwn.setClickHandler([](Button2 & b) {
        // Down
        nav.doNav(upCmd); // It's called upCmd because it increases the index of an array. Visually that would mean the selector goes downwards.
    });
}

//////////////////////////////////////////////////////////////////////////////////////////////////

void button_loop()
{
    // Check for button presses
    btnUp.loop();
    btnDwn.loop();

}



//////////////////////////////////////////////////////////////////////////////////////////////////
//================================================================================================

void setup() {

   Serial.begin(115200);
   pinMode(BUTTON_3, INPUT_PULLUP);
 
   sampling_period_us = round(1000ul * (1.0 / MAX_FREQ));
   chrono1 = millis();
   pinMode(LED_1, OUTPUT);



////////////////////////////////////////////////////////////////////////////////////SOUNDS
/*
    tone(BUZZER_PIN, NOTE_C7, 100, BUZZER_CHANNEL);
    tone(BUZZER_PIN, NOTE_C6, 200, BUZZER_CHANNEL);
    noTone(BUZZER_PIN, BUZZER_CHANNEL);
*/
////////////////////////////////////////////////////////////////////////////////// BME-Clima/Tempo


  Serial.println("ESPNow/Basic/Client Example");
  //Set device in AP mode to begin with
  WiFi.mode(WIFI_AP);
  // configure device AP mode
  //configDeviceAP();
  // This is the mac address of the Client in AP Mode
  //Serial.print("AP MAC: "); Serial.println(WiFi.softAPmacAddress());
  // Init ESPNow with a fallback logic
  //InitESPNow();
  // Once ESPNow is successfully Init, we will register for recv CB to
  // get recv packer info.
  //esp_now_register_recv_cb(OnDataRecv);

//////////////////////////////////////////////////////////////////////////////////////
  Serial.println(F("BME280 test"));
  bool status;
  // default settings
  // (you can also pass in a Wire library object like &Wire2)
  status = bme.begin(0x76);  
  if (!status) {
    Serial.println("Could not find a valid BME280 sensor, check wiring!");
    while (1);
  }
///////////////////////////////////////////////////////////////////////////////// IMU-Magnetometer

  while (!Serial) {}

  // start communication with IMU
  status = IMU.begin();
  if (status < 0) {
    Serial.println("IMU initialization unsuccessful");
    Serial.println("Check IMU wiring or try cycling power");
    Serial.print("Status: ");
    Serial.println(status);
    while (1) {}
  }

////////////////////////////////////////////////////////////////////////////////// CO2 Atmosphere

      if(!ccs.begin()){
      Serial.println("Failed to start sensor! Please check your wiring.");
      while(1);
      }

////////////////////////////////////////////////////////////////////////////////// LIDAR
                                                                       
  Wire.begin();
  Wire.setClock(400000); // use 400 kHz I2C
  sensor.setTimeout(500);
  if (!sensor.init())
  {
    Serial.println("Failed to detect and initialize sensor!");
    while (1);
  }  
  // Use long distance mode and allow up to 50000 us (50 ms) for a measurement.
  // You can change these settings to adjust the performance of the sensor, but
  // the minimum timing budget is 20 ms for short distance mode and 33 ms for
  // medium and long distance modes. See the VL53L1X datasheet for more
  // information on range and timing limits.
  sensor.setDistanceMode(VL53L1X::Long);
  sensor.setMeasurementTimingBudget(50000);
  // Start continuous readings at a rate of one measurement every 50 ms (the
  // inter-measurement period). This period should be at least as long as the
  // timing budget.
  sensor.startContinuous(50);

////////////////////////////////////////////////////////////////////////////////// UV LIGHT
                                                                                                                                                   
  Serial.println("Adafruit SI1145 test");
  if (! uv.begin()) {
    Serial.println("Didn't find Si1145");
    while (1);
  }
  Serial.println("OK!");
  
////////////////////////////////////////////////////////////////////////////////// SPECTROGRAPH

      AS7265X.I2Cscan();
      Serial.print("I2C scan done");

      AS7265X.init(gain, mode, intTime);

      delay(100);

      //Configure leds, for devices 0 (master), 1 and 2 (slaves)
      AS7265X.configureLed(ledIndCurrent0, ledDrvCurrent0, 0);
      AS7265X.disableIndLed(0);
      AS7265X.disableDrvLed(0);
      delay(100);
      
      AS7265X.configureLed(ledIndCurrent1, ledDrvCurrent1, 1);
      AS7265X.disableIndLed(1);
      AS7265X.enableDrvLed(1);
      delay(100);
      AS7265X.configureLed(ledIndCurrent2, ledDrvCurrent2, 2);
      AS7265X.disableIndLed(2);
      AS7265X.disableDrvLed(2);
      delay(100);

      AS7265X.disableDrvLed(1);     //LED aus
      // delay(500); AS7265X.enableDrvLed(1);    //LED an

      if (gain == 0)gainX = 1;
      if (gain == 1)gainX = 4; // default
      if (gain == 2)gainX = 16;
      if (gain == 3)gainX = 64;
      
      attachInterrupt(intPin, myIntHandler, FALLING); 
           
      AS7265X.getStatus();
      
      AS7265X.disableIndLed(0);
      
     // t = millis();
      modus = 'N';

 //////////////////////////////////////////////////////////////////////////////////////////////////

  Serial.println("Adafruit I2C GPS library basic test!");

  // 9600 NMEA is the default baud rate for Adafruit MTK GPS's- some use 4800
  GPS.begin(0x10);  // The I2C address to use is 0x10
  // uncomment this line to turn on RMC (recommended minimum) and GGA (fix data) including altitude
  GPS.sendCommand(PMTK_SET_NMEA_OUTPUT_RMCGGA);
  // uncomment this line to turn on only the "minimum recommended" data
  //GPS.sendCommand(PMTK_SET_NMEA_OUTPUT_RMCONLY);
  // For parsing data, we don't suggest using anything but either RMC only or RMC+GGA since
  // the parser doesn't care about other sentences at this time
  // Set the update rate
  GPS.sendCommand(PMTK_SET_NMEA_UPDATE_1HZ); // 1 Hz update rate
  // For the parsing code to work nicely and have time to sort thru the data, and
  // print it out we don't suggest using anything higher than 1 Hz

  // Request updates on antenna status, comment out to keep quiet
  GPS.sendCommand(PGCMD_ANTENNA);

  delay(1000);

  // Ask for firmware version
  GPS.println(PMTK_Q_RELEASE);

///////////////////////////////////////////////////////////////////////////////////////////////////////

// default settings
  if (!amg.begin()) {
    Serial.println("Could not find a valid AMG88xx sensor, check wiring!");
    while (1) { delay(1); }
  }
    
  Serial.println("-- Thermal Camera Test --");
  //teste();
//}

///////////////////////////////////////////////////////////////////////////////////////////////////////

      if (!particleSensor.begin(Wire, I2C_SPEED_FAST)) //Use default I2C port, 400kHz speed
      {
      Serial.println("MAX30105 was not found. Please check wiring/power. ");
      while (1);
      }
      particleSensor.setup(); //Configure sensor. Use 6.4mA for LED drive

  particleSensor.setPulseAmplitudeRed(0); //Turn off Red LED
  particleSensor.setPulseAmplitudeGreen(0); //Turn off Green LED

///////////////////////////////////////////////////////////////////////////////////////////////////////

 // ledcAttachPin(TONE_OUTPUT_PIN, TONE_PWM_CHANNEL);  
  radiationWatch.setup();
  radiationWatch.registerRadiationCallback(&onRadiation);
  radiationWatch.registerNoiseCallback(&onNoise);

  ///////////////////////////////////////////////////////////////////////////////////////////////////


  while(!Serial);
  Serial.flush();
  Serial.println();
  Serial.print("TRICORDUINO 4.0");
  Serial.print(PROG_VERSION);
  Serial.println(" FOR LILYGO TTGO T-DISPLAY");
  nav.idleTask=idle;//point a function to be used when menu is suspended
  display.init();
  Serial.print("Configuring PWM for TFT backlight... ");
  ledcSetup(pwmLedChannelTFT, pwmFreq, pwmResolution);
  ledcAttachPin(TFT_BL, pwmLedChannelTFT);
  Serial.println("DONE");
  Serial.print("Setting PWM for TFT backlight to default intensity... ");
  ledcWrite(pwmLedChannelTFT, ledBacklight);
  Serial.println("DONE");
  display.setRotation(3);
  display.setTextSize(2);  
  display.setTextWrap(false);
  display.fillScreen(Black);
  Serial.print("Showing bootlogo... ");
  display.setSwapBytes(true);
  display.pushImage(0,0,240,135,bootlogo);
  delay(1000);
  Serial.println("DONE");
  Serial.print("Initialize buttons... ");
  button_init();
  delay(1000);
  Serial.println("DONE");
  delay(2000); // A little bit more delay so that you will be able to see the bootlogo.
  Serial.println("- READY -");
  display.fillScreen(Black);

      pinMode(37, INPUT);
      pinMode(36, INPUT);
      pinMode(25, INPUT);
      pinMode(26, INPUT);
      pinMode(33, INPUT);
      pinMode(38, INPUT);
      pinMode(15, OUTPUT);
      pinMode(13, OUTPUT);
      pinMode(intPin, INPUT); // set up the interrupt pin
      
      analogReadResolution(12); // Define a resolução da leitura analógica (0-4095)
 
      Wire.begin(); // set master mode
      Wire.setClock(400000);      // I2C frequency at 400 kHz
      delay(100);
  
}

//==========================================================================================================
////////////////////////////////////////////////////////////////////////////////////////////////////////////
//==========================================================================================================
////////////////////////////////////////////////////////////////////////////////////////////////////////////


void loop() {
  
////////////////////////////////////////////////////////////////////////////////////////////////////////////
  button_loop();
 
  nav.poll();//this device only draws when needed

  //digitalWrite(LED_1, HIGH);
if (atmosphereCtrl == 0){
  
    digitalWrite(LED_1, LOW);
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////

  if (climaCtrl == 1){
  delay(250);
  float t = bme.readTemperature();
  float h = bme.readHumidity();
  float p = bme.readPressure();
  float a = bme.readAltitude(SEALEVELPRESSURE_HPA);
  float d = t-((100-h)/5);
  

  display.fillRect(110,0,200,135,TFT_BLACK);
  display.setTextSize(2);
  display.setTextColor(TFT_WHITE);

  display.setCursor(120,13);
  display.print(t);
  display.setCursor(210,13);
  display.print("C");
  
  display.setCursor(120,43);
  display.print(h);
  display.setCursor(210,43);
  display.print("%" );
  
  display.setCursor(120,68);
  display.print(p/100); 
  display.setCursor(200,68);
  display.print("Hpa" );
    
  display.setCursor(120,95); 
  display.print(a);
  display.setCursor(220,95);
  display.print("m" );
  
  display.setCursor(120,119);
  display.print(d);
  display.setCursor(210,119);
  display.print("C");
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////

  if (lightCtrl == 1){
  delay(250);
  float UVindex = uv.readUV();
  // the index is multiplied by 100 so to get the
  // integer index, divide by 100!
  UVindex /= 100.0;  
  
  display.fillRect(110,0,200,135,TFT_BLACK);
  display.setTextSize(2);
  display.setTextColor(TFT_WHITE);

  display.setCursor(120,13);
  display.print(uv.readVisible());
  display.setCursor(210,13);
    
  display.setCursor(120,43);
  display.print(uv.readIR());
  display.setCursor(210,43);
  
  display.setCursor(120,68);
  //display.print(uv.readUV()); 
  display.print(UVindex );
  display.setCursor(200,68);
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////

  if (somCtrl == 1){
  //delay(250);

  adc1_config_width(ADC_WIDTH_BIT_12);
  // ADC1 Channel 4 is GPIO 32 (microphone)
  // https://microcontrollerslab.com/wp-content/uploads/2019/03/ESP32-ADC-channels-pinout.jpg
  adc1_config_channel_atten(ADC1_CHANNEL_4, ADC_ATTEN_DB_11);
  calibrate();
  
    static int modes = 0;
    bool changeMode = false;
  // Push the button to change modes
  if (millis() - chrono1 > 1000ul) {
    if (digitalRead(BUTTON_3) == HIGH) { // Modes up
      delay(30);
      modes = (modes + 1) % MAXMODES;
      changeMode = true;
      chrono1 = millis();
    } 

  }
  switch (modes) {
    case 0: // Display spectrum
      acquireSound();
      displaySpectrum();
      break;
    case 1: // Display spectrum
      acquireSound();
      displaySpectrum2();
      break;
    case 2: // Display amplitude with bars
      displayAmplitudeBars();
      break;
    case 3: // Display envelope
      displayEnvelope(changeMode);
      break;
    case 4: // Display running amplitude
      displayRunningEnvelope(changeMode);
      break;
    case 5: // Display Spectrogram
      displaySpectrogram (changeMode, false);
      break;
    case 6: // Display Spectrogram with maxima in circles
      displaySpectrogram (changeMode, true);
      break;
     default:
      break;
  }
  // Touch GPIO 15 to stop the display
  const int touchPin = 12;
  const int threshold = 50;
  if (touchRead(touchPin) < threshold) while (touchRead(touchPin) < threshold);
 
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////

  if (SpectrographCtrl == 1){
  delay(250);

           Label();

                 if (intFlag)
            {
              intFlag = false;
            } 
           if (i <= 2) 
           {
            display.setTextColor(TFT_BLACK);
            Display_Value_delete ();            // draw over value with value in black
           }
              ButtonD2();       // Mode
              ButtonD3();       // Ganho
              ButtonD4();       // Time  
              ButtonD5();       // Calibration
                      
           //     
              if (i <= 2) 
              {    
                
                    //tft.setTextColor(TFT_BLACK);
                    //Display_Value_delete ();
                                         
                    freq_max=0; 
                    alpha_t_max=0;
                    alpha_r_max=0;
                    
                  statos = AS7265X.getStatus();   
                     
                    getValue (); 
                    Value (); 
                    
                    display.setTextColor(TFT_YELLOW);
                    Display_Value ();

                    delay(50);     // 50ms
                    
                  if (statos & 0x02)
               {
                        AS7265X.readCalData(calData);     
                      printSerial();     
                        //  AS7265X.enableIndLed(0); delay(10);  AS7265X.disableIndLed(0); // blink indicator led
                    }  
                }
                
               t = millis();
               }

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

  if (MagCtrl == 1){
  delay(250);
  IMU.readSensor();

  display.fillRect(110,0,200,135,TFT_BLACK);
  display.setTextSize(2);
  display.setTextColor(TFT_WHITE);

  display.setCursor(120,13);
  display.print(IMU.getMagX_uT());
  display.setCursor(210,13);
  display.print("uT");

  display.setCursor(120,43);
  display.print(IMU.getMagY_uT());
  display.setCursor(210,43);
  display.print("uT" );
  
  display.setCursor(120,68);
  display.print(IMU.getMagZ_uT()); 
  display.setCursor(210,68);
  display.print("uT" );

  float MagX = IMU.getMagX_uT();
  float MagY = IMU.getMagY_uT();
  float MagZ = IMU.getMagZ_uT();
  float MagM;
  MagM = sqrt(sq(MagX)+sq(MagY)+sq(MagZ)); 
  display.setCursor(120,95); 
  display.print(MagM);
  display.setCursor(210,95);
  display.print("uT" );

 // display the data
 // Serial.println(IMU.getAccelX_mss(), 6);
 // Serial.print("\t");
 // Serial.print(IMU.getAccelY_mss(), 6);
 // Serial.print("\t");
 // Serial.print(IMU.getAccelZ_mss(), 6);
 // Serial.print("\t");
 // Serial.print(IMU.getGyroX_rads(), 6);
 // Serial.print("\t");
 // Serial.print(IMU.getGyroY_rads(), 6);
  //Serial.print("\t");
 // Serial.print(IMU.getGyroZ_rads(), 6);
 // Serial.print("\t");
  Serial.print(IMU.getMagX_uT(), 6);
 // Serial.print("\t");
 // Serial.print(IMU.getMagY_uT(), 6);
 // Serial.print("\t");
  Serial.print(IMU.getMagZ_uT(), 6);
  Serial.print("\t");
  Serial.println(IMU.getTemperature_C(), 6);
  delay(100);
  }

//////////////////////////////////////////////////////////////////////////////////////////////////////////

  if (analogMeterCtrl == 1){
  delay(250);

  int somaLeituras = 0;

  for (int i = 0; i < numLeituras; i++) {
    int valorLeitura = analogRead(entradaAnalogica); // Realiza uma leitura analógica
    somaLeituras += valorLeitura;
    delay(10); // Aguarda um pequeno intervalo entre as leituras
  //Serial.println(100*valorLeitura);  
  }

  int mediaLeituras = somaLeituras / numLeituras; // Calcula a média das leituras
  //float logValor = -log10(mediaLeituras); // Calcula o logaritmo do valor médio
  //float valorAmplificado = logValor/1000 ; // Aplica o fator de amplificação

//   Serial.println(valorAmplificado); // Imprime o valor amplificado no monitor serial

int media = map(10*mediaLeituras, 0,4095,0,100);

//value[0] = mediaLeituras*10;
value[0] = media;
//value[0] = analogRead(Volt);
plotNeedle(value[0],0);
  }

////////////////////////////////////////////////////////////////////////////////////////////////////////////////

  if (gpsdisplayCtrl == 1){
  //delay(1000);
  delay(500);

  display.fillRect(110,0,200,135,TFT_BLACK);
  display.setTextSize(2);
  display.setTextColor(TFT_WHITE);
 
// read data from the GPS in the 'main loop'
  char c = GPS.read();
  // if you want to debug, this is a good time to do it!
  if (GPSECHO)
    if (c) Serial.print(c);
  // if a sentence is received, we can check the checksum, parse it...
  if (GPS.newNMEAreceived()) {
    // a tricky thing here is if we print the NMEA sentence, or data
    // we end up not listening and catching other sentences!
    // so be very wary if using OUTPUT_ALLDATA and trying to print out data
    Serial.println(GPS.lastNMEA()); // this also sets the newNMEAreceived() flag to false
    if (!GPS.parse(GPS.lastNMEA())) // this also sets the newNMEAreceived() flag to false
      return; // we can fail to parse a sentence in which case we should just wait for another
  }

  // approximately every 2 seconds or so, print out the current stats
  if (millis() - timer > 2000) {
    timer = millis(); // reset the timer
    Serial.print("\nTime: ");
    if (GPS.hour < 10) { Serial.print('0'); }
    Serial.print(GPS.hour, DEC); Serial.print(':');
    if (GPS.minute < 10) { Serial.print('0'); }
    Serial.print(GPS.minute, DEC); Serial.print(':');
    if (GPS.seconds < 10) { Serial.print('0'); }
    Serial.print(GPS.seconds, DEC); Serial.print('.');

  display.setCursor(120,13);
  display.print(GPS.hour);
  display.setCursor(145,13);
  display.print(":");
  display.setCursor(160,13);
  display.print(GPS.minute);
  display.setCursor(185,13);
  display.print(":");
  display.setCursor(200,13);
  display.print(GPS.seconds);
   
    if (GPS.milliseconds < 10) {
      Serial.print("00");
    } else if (GPS.milliseconds > 9 && GPS.milliseconds < 100) {
      Serial.print("0");
    }
    Serial.println(GPS.milliseconds);
    Serial.print("Date: ");
    Serial.print(GPS.day, DEC); Serial.print('/');
    Serial.print(GPS.month, DEC); Serial.print("/20");
    Serial.println(GPS.year, DEC);

  display.setCursor(115,43);
  display.print(GPS.day);
  display.setCursor(140,43);
  display.print('/');
  display.setCursor(150,43);
  display.print(GPS.month);
  display.setCursor(175,43);
  display.print("/20");
  display.setCursor(215,43);
  display.print(GPS.year);
  
    
      Serial.print("Fix: "); Serial.print((int)GPS.fix);
      Serial.print(" quality: "); Serial.println((int)GPS.fixquality);
      if (GPS.fix) {
      Serial.print("Location: ");
      Serial.print(GPS.latitude, 4); Serial.print(GPS.lat);
      Serial.print(", ");
      Serial.print(GPS.longitude, 4); Serial.println(GPS.lon);
      Serial.print("Speed (knots): "); Serial.println(GPS.speed);
      Serial.print("Angle: "); Serial.println(GPS.angle);
      Serial.print("Altitude: "); Serial.println(GPS.altitude);
      Serial.print("Satellites: "); Serial.println((int)GPS.satellites);

  display.setCursor(120,68);
  display.print(GPS.latitude,4);
  display.setCursor(120,95); 
  display.print(GPS.longitude,4);  
  display.setCursor(120,119);
  display.print(GPS.altitude); 
  display.setCursor(215,119);
  display.print("m");     
    }    
  }
  }

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

  if (thermocamCtrl == 1){
    display.setTextSize(2);
    display.setTextColor(TFT_WHITE, TFT_BLACK);

  float p = sensor.read();
  display.setTextSize(2);

  display.setCursor(130,45);
  display.print("Distance"); 
  display.setCursor(135,65);
  display.print(p/10);
  display.setCursor(210,65);
  display.print("cm" );

  //read all the pixels
  amg.readPixels(pixels);

  Serial.print("[");
  HighTemp=0;
 
  for(int i=1; i<=AMG88xx_PIXEL_ARRAY_SIZE; i++){
    Serial.print(pixels[i-1]);
    Serial.print(", ");
    if( i%8 == 0 ) Serial.println();
    if (pixels[i-1] > HighTemp) HighTemp = pixels[i-1];
    //if (pixels[i-1] < HighTemp) LowTemp = pixels[i-1];
  }
   
  Serial.println("]");
  Serial.println();
  HTemp = ((HighTemp * 9/5) + 32);
  Serial.println (HTemp);
 
  float dest_2d[INTERPOLATED_ROWS * INTERPOLATED_COLS];

  int32_t t = millis();
  interpolate_image(pixels, AMG_ROWS, AMG_COLS, dest_2d, INTERPOLATED_ROWS, INTERPOLATED_COLS);
  Serial.print("Interpolation took "); Serial.print(millis()-t); Serial.println(" ms");

  uint16_t boxsize = min(display.width() / INTERPOLATED_COLS, display.height() / INTERPOLATED_COLS);
 
  drawpixels(dest_2d, INTERPOLATED_ROWS, INTERPOLATED_COLS, boxsize, boxsize, false);

  //delay(50);
  }

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

if (geigerCtrl == 1){ 
//  radiationWatch.registerRadiationCallback(&onRadiation); 
//  radiationWatch.registerNoiseCallback(&onNoise);  
  radiationWatch.loop(); 
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

if (stormCtrl == 1){
  delay(250);

  display.fillRect(150, 53, 240, 193, TFT_BLACK);
  
  int average = analogRead(36);
  int nivel = map(average, 4095,2000, 0, 2000);


  //int nivel = map(average, 4095,0, 0, 4000);
  display.setTextColor(TFT_WHITE);
  display.setCursor(160,92); 
  display.print(nivel);
  display.setTextColor(TFT_ORANGE);
  display.setCursor(200,92); 
  display.print("uA");
  float ni = 100*average;
  Serial.println(ni);

  IMU.readSensor();
  float MagX = IMU.getMagX_uT();
  float MagY = IMU.getMagY_uT();
  float MagZ = IMU.getMagZ_uT();
  float MagM;
  MagM = sqrt(sq(MagX)+sq(MagY)+sq(MagZ)); 
  display.setFreeFont(&lcars11pt7b);
  display.setTextColor(TFT_WHITE);
  display.setCursor(160,122); 
  display.print(MagM);
  display.setTextColor(TFT_ORANGE);
  display.setCursor(200,122); 
  display.print("uT");

  Leq_dB = average;
  Leq_dB2 = MagM;
  findFieldLevel();                                                       
  }

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

if (atmosphereCtrl == 1){
  
    
    digitalWrite(LED_1, HIGH);
    
   float h = bme.readHumidity();
   float t = bme.readTemperature();
   
    if(!ccs.readData()){
      delay(250);
      Serial.print("CO2: ");
      Serial.print(ccs.geteCO2());
      Serial.print("ppm, TVOC: ");
      Serial.println(ccs.getTVOC());
       //Serial.print("ppb Temp:");
      //Serial.println(temp);
      
    }
    else{
      Serial.println("ERROR!");
     while(1);
    }   
   
  display.fillRect(110,0,200,135,TFT_BLACK);
  display.setTextSize(2);
  display.setTextColor(TFT_WHITE);

  display.setCursor(120,13);
  display.print(ccs.geteCO2());
  display.setCursor(200,13);
  display.print("ppm");

  display.setCursor(120,43);
  display.print(ccs.getTVOC());
  display.setCursor(200,43);
  display.print("ppm" );

  display.setCursor(120,68);
  display.print(h);
  display.setCursor(210,68);
  display.print("%" );

  display.setCursor(120,95); 
  display.print(t);
  display.setCursor(210,95);
  display.print("C" );

    if(ccs.geteCO2()>1000){
     
    tone(BUZZER_PIN, NOTE_C7, 50, BUZZER_CHANNEL);
    tone(BUZZER_PIN, NOTE_C8, 80, BUZZER_CHANNEL);
    tone(BUZZER_PIN, NOTE_C7, 50, BUZZER_CHANNEL);
       tone(BUZZER_PIN, NOTE_C7, 50, BUZZER_CHANNEL);
    tone(BUZZER_PIN, NOTE_C8, 80, BUZZER_CHANNEL);
    tone(BUZZER_PIN, NOTE_C7, 50, BUZZER_CHANNEL);

    tone(BUZZER_PIN, NOTE_C7, 50, BUZZER_CHANNEL);
    tone(BUZZER_PIN, NOTE_C8, 80, BUZZER_CHANNEL);
    tone(BUZZER_PIN, NOTE_C7, 50, BUZZER_CHANNEL);
       tone(BUZZER_PIN, NOTE_C7, 50, BUZZER_CHANNEL);
    tone(BUZZER_PIN, NOTE_C8, 80, BUZZER_CHANNEL);
    tone(BUZZER_PIN, NOTE_C7, 50, BUZZER_CHANNEL);
   
    tone(BUZZER_PIN, NOTE_C7, 50, BUZZER_CHANNEL);
    tone(BUZZER_PIN, NOTE_C8, 80, BUZZER_CHANNEL);
    tone(BUZZER_PIN, NOTE_C7, 50, BUZZER_CHANNEL);
       tone(BUZZER_PIN, NOTE_C7, 50, BUZZER_CHANNEL);
    tone(BUZZER_PIN, NOTE_C8, 80, BUZZER_CHANNEL);
    tone(BUZZER_PIN, NOTE_C7, 50, BUZZER_CHANNEL);

    tone(BUZZER_PIN, NOTE_C7, 50, BUZZER_CHANNEL);
    tone(BUZZER_PIN, NOTE_C8, 80, BUZZER_CHANNEL);
    tone(BUZZER_PIN, NOTE_C7, 50, BUZZER_CHANNEL);
       tone(BUZZER_PIN, NOTE_C7, 50, BUZZER_CHANNEL);
    tone(BUZZER_PIN, NOTE_C8, 80, BUZZER_CHANNEL);
    tone(BUZZER_PIN, NOTE_C7, 50, BUZZER_CHANNEL);

       tone(BUZZER_PIN, NOTE_C7, 50, BUZZER_CHANNEL);
    tone(BUZZER_PIN, NOTE_C8, 80, BUZZER_CHANNEL);
    tone(BUZZER_PIN, NOTE_C7, 50, BUZZER_CHANNEL);
       tone(BUZZER_PIN, NOTE_C7, 50, BUZZER_CHANNEL);
    tone(BUZZER_PIN, NOTE_C8, 80, BUZZER_CHANNEL);
    tone(BUZZER_PIN, NOTE_C7, 50, BUZZER_CHANNEL);

    tone(BUZZER_PIN, NOTE_C7, 50, BUZZER_CHANNEL);
    tone(BUZZER_PIN, NOTE_C8, 80, BUZZER_CHANNEL);
    tone(BUZZER_PIN, NOTE_C7, 50, BUZZER_CHANNEL);
       tone(BUZZER_PIN, NOTE_C7, 50, BUZZER_CHANNEL);
    tone(BUZZER_PIN, NOTE_C8, 80, BUZZER_CHANNEL);
    tone(BUZZER_PIN, NOTE_C7, 50, BUZZER_CHANNEL);
   
    tone(BUZZER_PIN, NOTE_C7, 50, BUZZER_CHANNEL);
    tone(BUZZER_PIN, NOTE_C8, 80, BUZZER_CHANNEL);
    tone(BUZZER_PIN, NOTE_C7, 50, BUZZER_CHANNEL);
       tone(BUZZER_PIN, NOTE_C7, 50, BUZZER_CHANNEL);
    tone(BUZZER_PIN, NOTE_C8, 80, BUZZER_CHANNEL);
    tone(BUZZER_PIN, NOTE_C7, 50, BUZZER_CHANNEL);

    tone(BUZZER_PIN, NOTE_C7, 50, BUZZER_CHANNEL);
    tone(BUZZER_PIN, NOTE_C8, 80, BUZZER_CHANNEL);
    tone(BUZZER_PIN, NOTE_C7, 50, BUZZER_CHANNEL);
       tone(BUZZER_PIN, NOTE_C7, 50, BUZZER_CHANNEL);
    tone(BUZZER_PIN, NOTE_C8, 80, BUZZER_CHANNEL);
    tone(BUZZER_PIN, NOTE_C7, 50, BUZZER_CHANNEL); 
    }
    if(ccs.geteCO2()<1000){
noTone(BUZZER_PIN, BUZZER_CHANNEL);
    } 
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

  if (lidarCtrl == 1){
    delay(300);
  float p = sensor.read();
  //Serial.print(sensor.read());
  Serial.print(p);
  if (sensor.timeoutOccurred()) { Serial.print(" TIMEOUT"); }

  display.fillRect(30,40,210,80,TFT_BLACK);
  display.setTextSize(2);
  display.setTextColor(TFT_WHITE);

  int numReadings = 10;
int total = 0;
for (int i = 0; i < numReadings; i++) {total += sensor.read();
delay(50);
}
int average = total / numReadings;
average = average/10;

  display.setTextSize(3);
  display.setCursor(100,58);
  display.print(average);
   //display.setTextColor(TFT_GREEN);
  display.setCursor(40,95);
  display.print("centimetros" );

  Serial.println();
  }

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  
if (betaCtrl ==1){


  particleSensor.setPulseAmplitudeRed(255); //Turn off Red LED
  particleSensor.setPulseAmplitudeGreen(255); //Turn off Green LED
  
        float vala = particleSensor.getRed();
  int totali = 0;
  for (int i = 0; i < 10; i++) {totali += particleSensor.getRed(); 
  }
  float averageRed = totali /20;

        
        float valb = particleSensor.getIR();
  int totalj = 0;
  for (int j = 0; j < 10; j++) {totalj += particleSensor.getIR(); 
  }
  float averageIR = totalj /20;

        
        float valc = particleSensor.getGreen();
  int totalk = 0;
  for (int k = 0; k < 10; k++) {totalk += particleSensor.getGreen(); 
  }
  float averageGreen = totalk /20;

         Serial.print(vala);
         Serial.print(valb);
         Serial.println(valc);

  delay(50);

  display.fillRect(110,0,200,135,TFT_BLACK);
  display.setTextSize(2);
  display.setTextColor(TFT_WHITE);

  display.setCursor(120,13);
  // display.print(vala);
  display.print(averageRed);
  display.setCursor(210,13);
  display.print("");
  
  display.setCursor(120,43);
  //display.print(valb);
  display.print(averageIR);
  display.setCursor(210,43);
  display.print("" );
  
  display.setCursor(120,68);
  //display.print(valc);
  display.print(averageGreen); 
  display.setCursor(200,68);
  display.print("" ); 
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

if (RecvCtrl ==1){
} 

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

if (oscilloscopeCtrl ==1){
 
  ADC_Sampling(i2s_buff);
  update_screen(i2s_buff, RATE);
  
 delay(200);
}
}
