
int voltage_division[6] = { //screen has 4 divisions, 31 pixels each (125 pixels of height)
  825, //fullscreen 3.3V peak-peak
  750,
  500,
  250,
  100,
  50
};

float time_division[9] = { //screen has 4 divisions, 60 pixel each (240 pixel of width)
  10,
  25,
  50,
  100,
  250,
  500,
  1000,
  2500,
  5000
};



float to_scale(float reading) {
  float temp = WIDTH - (((float)((reading - 20480.0) / 4095.0) + (coffset / 3.3)) * 3300 / (v_div * 4)) * (WIDTH - 1) - 1;
  return temp;
}

void update_screen(uint16_t *i2s_buff, float sample_rate) {
  float mean = 0;
  float max_v, min_v;
  peak_mean(i2s_buff, BUFF_SIZE, &max_v, &min_v, &mean);
  draw_display(1000, mean, max_v, min_v);
}

void draw_display(float freq, float mean, float max_v, float min_v) {
  max_v = to_voltage(max_v);
  min_v = to_voltage(min_v);

  // Preencha toda a tela com preto
  display.fillScreen(TFT_BLACK);

  draw_grid();

  // Desenhe o canal
  draw_channel1(0, 0, i2s_buff, 1000);

  // Informações
/*
  display.drawString("Freq: 1000Hz", 5, 5);
  display.drawString("Mean: " + String(mean * 1000.0) + "mV", 5, 15);
  display.drawString("Max: " + String(max_v) + "V", 5, 25);
  display.drawString("Min: " + String(min_v) + "V", 5, 35);

  display.setTextColor(TFT_WHITE);
  display.setTextSize(1);
  display.setCursor(105,12);
  display.print("MagX:");
  */
display.setTextColor(TFT_WHITE);
display.setTextSize(1); 
display.setCursor(5,5);
display.print("Freq: 1000Hz");
display.setCursor(5,15);
display.print("Mean: ");
display.setCursor(40,15);
display.print(mean*1000.0);
display.setCursor(5,25);
display.print("Max: ");
display.setCursor(40,25);
display.print(max_v);
display.setCursor(5,35);
display.print("Min: ");
display.setCursor(40,35);
display.print(min_v);
 
}

void draw_grid() {
  for (int i = 0; i < 24; i++) {
    display.drawPixel(i * 10, 33, TFT_WHITE);
    display.drawPixel(i * 10, 67, TFT_WHITE);
    display.drawPixel(i * 10, 101, TFT_WHITE);
  }
  for (int i = 0; i < 135; i += 10) {
    for (int j = 0; j < 240; j += 34) {
      display.drawPixel(j, i, TFT_WHITE);
    }
  }
}
int data1[240] = {0};
void draw_channel1(uint32_t trigger0, uint32_t trigger1, uint16_t *i2s_buff, float sample_rate) {
  data1[0] = to_scale(i2s_buff[trigger0]);
  low_pass filter(0.99);
  mean_filter mfilter(5);
  mfilter.init(i2s_buff[trigger0]);
  filter._value = i2s_buff[trigger0];
  float data_per_pixel = (s_div / 34.0) / (sample_rate / 1000);
  uint32_t index_offset = (uint32_t)(toffset / data_per_pixel);
  trigger0 += index_offset;  
  uint32_t old_index = trigger0;
  float n_data = 0, o_data = to_scale(i2s_buff[trigger0]);
  for (uint32_t i = 1; i < 240; i++) {
    uint32_t index = trigger0 + (uint32_t)((i + 1) * data_per_pixel);
    if (index < BUFF_SIZE) {
      if (full_pix && s_div > 34 && current_filter == 0) {
        uint32_t max_val = i2s_buff[old_index];
        uint32_t min_val = i2s_buff[old_index];
        for (int j = old_index; j < index; j++) {
          if (i2s_buff[j] > max_val)
            max_val = i2s_buff[j];
          else if (i2s_buff[j] < min_val)
            min_val = i2s_buff[j];
        }
        display.drawLine(i, to_scale(min_val), i, to_scale(max_val), TFT_BLUE);
      }
      else {
        if (current_filter == 2)
          n_data = to_scale(mfilter.filter((float)i2s_buff[index]));
        else if (current_filter == 3)
          n_data = to_scale(filter.filter((float)i2s_buff[index]));
        else
          n_data = to_scale(i2s_buff[index]);

        display.drawLine(i - 1, o_data, i, n_data, TFT_BLUE);
        o_data = n_data;
      }
    }
    else {
      break;
    }
    old_index = index;
  }
}
